#ifndef __DATA_DEFINE_H__
#define __DATA_DEFINE_H__

#define BRAND_ID_ALL (0x00000000)
#define BRAND_ID_OTHER (0xFFFFFFFF)

typedef enum
{
	APPLIANCE_OTHER = 0,
	APPLIANCE_TV		= 1,
	APPLIANCE_AIR	= 2,
	APPLIANCE_FAN	= 3,
	APPLIANCE_PROJECTOR	= 4,
	APPLIANCE_STB	= 5,
	APPLIANCE_DVD	= 6,
	APPLIANCE_CAM	 = 7,
	APPLIANCE_LIGHT	= 8,
	APPLIANCE_AMPLIFIER		= 9,
	APPLIANCE_IPTY	= 10,
	APPLIANCE_BOX	= 11
}APPLIANCETYPE;

typedef enum
{
	ZERO							= 0,
	ONE							= 1,
	TWO							= 2,
	THREE							= 3,
	FOUR							= 4,
	FIVE								= 5,
	SIX								= 6,
	SEVEN							= 7,
	EIGHT							= 8,
	NINE							= 9,
	POWER						= 800,
	SIGNAL						= 801,
	INFORMATION			= 802,
	LOOK_BACK				= 803,
	MUTE							= 804,
	DIGITAL						= 805,
	BACK							= 806,
	CHANNEL_UP			= 807,
	CHANNEL_DOWN	= 808,
	VOL_UP						= 809,
	VOL_DOWN				= 810,
	D_ZOOM_UP				= 813,
	D_ZOOM_DOWN		= 814,
	MEMORY_ONE			= 815,
	MEMORY_TWO		= 816,
	MENU_OK					= 817,
	MENU_UP					= 818,
	MENU_DOWN			= 819,
	MENU_LEFT				= 820,
	MENU_RIGHT			= 821,
	MENU							= 822,
	MENU_EXIT				= 823,
	FORWARD					= 824,
	REWIND						= 825,
	PALY_PAUSE				= 826,
	STOP							= 827,
	PREVIOUS					= 828,
	NEXT							= 829,
	TOP								= 830,
	BOTTOM					= 831,
	HEAD_SHAKING		= 832,
	WIND_CLASS			= 837,
	WIND_VELOCITY		= 838,
	OPEN							= 839,
	TITLE							= 840,
	TEN_PLUS					= 841,
	LANGUAGE				= 842,
	SCREEN						= 843,
	SOUND_CHANNEL	= 844,
	STANDARD				= 845,
	SUBTITLES					= 846,
	DUAL_SCREEN			= 847,
	FREEZE						= 848,
	RESET							= 849,
	VIDEO							= 850,
	STEP_SLOW				= 851,
	SHUTTER_ONE			= 852,
	SHUTTER_TWO			= 853,
	CONTINUE_UP			= 854,
	CONTINUE_DOWN	= 855,
	CONTINUE_RIGHT	= 856,
	CONTINUE_LEFT		= 857,
	///////////////////////////////////////////////////////////
	TEMP_UP					= 811,
	TEMP_DOWN			= 812,
	MODE							= 832,
	WIND_AMOUNT		= 833,
	WIND_HORIZONTAL	= 834,
	WIND_VERTICAL			= 835,
	AIR_WIND_DIRECT		= 870,
	AIR_LIGHT						= 871,
	AIR_SUPER						= 872,
	AIR_SLEEP						= 873,
	AIR_FALSH_AIR			= 874,
	AIR_AID_HOT				= 875,
	AIR_TIME						= 876,
	AIR_WET						= 877,
	AIR_ANION					= 878,
	AIR_POWER_SAVING	= 879,
	AIR_COMFORT				= 880,
	AIR_TEMP_DISPLAY		= 881,
	AIR_QUICK_COOL		= 882,
	AIR_QUICK_HOT			= 883,
	/////////////////////////////////////////////////////////  
	AUTO								= 900,
	PJT_SIGNAL					= 901,
	BRIGHTNESS					= 902,
	PC									= 903,
	COOL_WIND					= 1000,
	HOME								= 1010,
	SETTING							= 1011,
	POP_MENU					= 1012,
	TOP_MENU					= 1013,
	POWER_SECOND			= 1800,
	BASE_ROUND				= -100,
	BASE_OVAL					= -99,
	BASE_SQUARE				= -98,
	BASE_OVAL_RED			= -97,
	BASE_OVAL_ORANGE	= -96,
	BASE_OVAL_YELLOW	= -95,
	BASE_OVAL_GREEN		= -94,
	BASE_OVAL_BLUE		= -93,
	BASE_OVAL_CYAN		= -92,
	BASE_OVAL_PURPLE	= -91,
	MEMORYKEY				= -90,
	FAVORITES					= 2001,
	NUMBERS						= 2002,
	CUSTOM						= 2003
}KEY_TYPE;


int GetType(const char* name);
const char* GetName(int type);
#endif
